this.BD = this.BD || {};

(function(){

    function Balls(){
        
		var ball, ballposx, ballposy, shooting, p1, p2;
        var balls = [];
		
        
        this.shoot = function(_p1, _p2, who){
            p1 = _p1;
            p2 = _p2;
            
			var ballbmp = queue.getResult("ball")
            ball = new createjs.Bitmap(ballbmp);
            ball.scaleX = 0.04;
            ball.scaleY = ball.scaleX;
            stage.addChildAt(ball, 5);
            ball.regX = ballbmp.width/2;
            ball.regY = ballbmp.height/2;
            
            /*
            if (dir == SHOOT_AT_ENEMY){
                var p1 = {x:player.getPos().x, y:player.getPos().y+70};
                var p2 = crosshair.getPos();
            } else {
                var p1 = {x:enemy.getPos().x, y:player.getPos().y+70};
                var p2 = crosshair.getPos();
            }
            */
            
            ball.x = p1.x;
            ball.y = p1.y;
            
            // angle in radians
            var angleRadians = Math.atan2(p2.y - p1.y, p2.x - p1.x);
            // angle in degrees
            var angleDeg = Math.atan2(p2.y - p1.y, p2.x - p1.x) * 180 / Math.PI;
            
            var angle = angleDeg + 90;
            var thrust = 80;
            var velY = -Math.cos(angle * Math.PI / 180) * thrust;
            var velX = Math.sin(angle * Math.PI / 180) * thrust;
            
            balls.push({who:who, mc:ball, x:p1.x, y:p1.y, targetx:p2.x, targety:p2.y, xspeed:velX, yspeed:velY});

            
            if (!barriers.hitSky() || barriers.hitBarrier()){

                var depth = 5;
                if (who != "player" || !player.getExposed()){
                    depth = 5;
                }

                var splatbmp = queue.getResult("splat") 
                var splat = new createjs.Bitmap(splatbmp);
                var targetscale = (0.3+(p2.y/500))/1.5;
                splat.scaleX = 0;
                splat.scaleY = splat.scaleX;
                stage.addChildAt(splat, depth);
                splat.regX = splatbmp.width/2;
                splat.regY = splatbmp.height/2;
                splat.x = p2.x;
                splat.y = p2.y;
				
				var r = Math.floor(Math.random()*3)+1;
				createjs.Sound.play("hit"+r);
				
                if (who == "player" || player.getExposed()){
                    splat.rotation = Math.random()*180;
                    createjs.Tween.get(splat).to({scaleX:targetscale, scaleY:targetscale, rotation:splat.rotation-15+Math.random()*30}, 150).wait(500).to({alpha:0}, 100);

                } else {
                    if (splat.y){
                        splat.y = 210+Math.random()*10
                        splat.x = 310+Math.random()*270;
                        //splat.scaleX = targetscale/2;
                        //splat.scaleY = targetscale/2;
                        createjs.Tween.get(splat).to({scaleX:targetscale/1.2, scaleY:targetscale/2.4, rotation:splat.rotation-1+Math.random()*1}, 150).wait(500).to({alpha:0}, 100);

                    }
                }

                var spd = 120*(targetscale) 

                //create bits
                for (var i=1; i<6; i++){
                    var splatbmp = queue.getResult("splat") 
                    var blob = new createjs.Bitmap(splatbmp);
                    blob.scaleX = targetscale/2;
                    blob.scaleY = blob.scaleX;
                    stage.addChildAt(blob, depth);
                    blob.regX = splatbmp.width/2;
                    blob.regY = splatbmp.height/2;
                    blob.x = splat.x;
                    blob.y = splat.y;

                    blob.rotation = Math.random()*180;
                    createjs.Tween.get(blob).to({
                        scaleX:0, 
                        scaleY:0, 
                        x:splat.x-spd+Math.random()*(spd*2),
                        y:splat.y-spd+Math.random()*(spd*2)
                    }, 250);

                }

            }
          
        }
		
        
        this.getBalls = function(){
            return balls;
        }
        
        this.update = function(){
            for (var i=0; i<balls.length; i++){
				if (balls[i]){
					balls[i].mc.x += balls[i].xspeed;
					balls[i].mc.y += balls[i].yspeed;
					balls[i].mc.scaleX -= 0.005;
					balls[i].mc.scaleY -= 0.005;

					var chpos = crosshair.getPos();
					
                    if (p1.y>p2.y && balls[i].mc.y < chpos.y){
						stage.removeChild(balls[i].mc);
						balls[i] = null;
					}
                    
                    if (p1.y<p2.y && balls[i].mc.y > p2.y){
						stage.removeChild(balls[i].mc);
						balls[i] = null;
					}
				}
            }
        }
        
    }
    
    BD.Balls = Balls;
    
}())