this.BD = this.BD || {};

(function(){

    
    function Enemy(o){

        var params = o || {};

        var _this = this;
        
        var mc;
		
        var direction = null;
        var run_for_cover = false;
        var exposure_count = 0;
        var decision_interval = 1000;
        
        var SPEED = 5;
        var MOVE_NONE = 0;
        var MOVE_LEFT = 1;
        var MOVE_RIGHT = 2;
        
        var shooting = false;
     
        var posy;
        var tweening;
        
        var active = true;
        
		init();
        
        function init(){
            mc = new createjs.Container();
            if (params.menu) {
                stage.addChild(mc);
                mc.scaleX = 0.8;
			
            } else {
                stage.addChildAt(mc, 2);
                mc.scaleX = 0.5;
            }
            mc.scaleY = mc.scaleX;
            mc.defaultScaleX = mc.scaleX;
            
            
            var bmp = queue.getResult("char_cameron_front"); // person_2
			var mc1 = new createjs.Bitmap(bmp);
			mc.mc1 = mc1 
            mc1.regX = 43;
			mc.addChild(mc1);
            
            var bmp = queue.getResult("char_cameron_front_hit")
			mc.hitmc = new createjs.Bitmap(bmp);
			mc.hitmc.regX = 43;
            mc.hitmc.visible = false;
			mc.addChild(mc.hitmc);
            
            var asset;
            if (params.placard){
                asset = "char_donkey_head"
            } else if (params.clarkson){
                asset = "char_clarkson_head"
            } else if (playerid == 1){
                asset = "char_farage_head"
            } else if (playerid == 2){
                asset = "char_cameron_head"
            } else  if (playerid == 3){
                asset = "char_clegg_head"
            }  else {
                asset = "char_milliband_head"
            }

            var bmp = queue.getResult(asset); // person_2
			var mchead = new createjs.Bitmap(bmp);
			mc.mchead = mchead 
            mchead.regX = 50;
            mchead.regY = 200;
            mchead.x = 100;
            mchead.y = 210;
            
            if (params.clarkson){
                mchead.x = 120;
                mchead.y = 140;
                speed_inc = 0.5;
                direction = 1;
            }
            
			mc.addChild(mchead);
            
			var asset;
            if (params.clarkson){
                asset = "char_clarkson_head_hit"
            }  else {
                asset = "char_cameron_head_hit"
            }
            var bmp = queue.getResult(asset);
			var mchithead = new createjs.Bitmap(bmp);
			mc.mchithead = mchithead 
            mchithead.regX = mchead.regX;
            mchithead.regY = mchead.regY;
            mchithead.x = mchead.x;
            mchithead.y = mchead.y;
            mchithead.visible = false;
			mc.addChild(mchithead);
            
            
            //
            mc.arm = new createjs.Container();
            mc.addChild(mc.arm);
            mc.arm.x = 67;
			mc.arm.y = 200;
            
            var armbmp = queue.getResult("char_cameron_front_arm")
			mc.armmc = new createjs.Bitmap(armbmp);
			//mc.armmc.x = 67;
			//mc.armmc.y = 200;
            mc.armmc.regX = 150;
            mc.armmc.regY = 130;
			mc.arm.addChild(mc.armmc);
            
            var armbmp = queue.getResult("char_cameron_back_arm_hit")
			mc.armhit = new createjs.Bitmap(armbmp);
			//mc.armhit.x = 67;
			//mc.armhit.y = 200;
            mc.armhit.regX = 150;
            mc.armhit.regY = 130;
            mc.armhit.visible = false;
			mc.arm.addChild(mc.armhit);
            
            var armbmp = queue.getResult("gunfire")
			mc.gunfiremc = new createjs.Bitmap(armbmp);
			mc.gunfiremc.x = -20;
			mc.gunfiremc.y = 130;
            mc.gunfiremc.regX = 75;
            mc.gunfiremc.visible = false;
            //mc.gunfiremc.regY = 150;
			mc.arm.addChild(mc.gunfiremc);
            
            
            /*
            var armbmp = queue.getResult("char_cameron_back_arm_hit")
			player.armhit = new createjs.Bitmap(armbmp);
			player.armhit.visible = false;
			player.addChild(player.armhit);
            */
            
            //player.addChild(player.mc1);
            
            if (params.placard){
                var bmp = queue.getResult("placard")
                mc.placardmc = new createjs.Bitmap(bmp);
                mc.placardmc.regX = 80;
                mc.placardmc.regY = 300;
                mc.placardmc.x = 117;
                mc.placardmc.y = 200;
                mc.addChild(mc.placardmc);

                var bmp = queue.getResult("placardhit")
                mc.placardhitmc = new createjs.Bitmap(bmp);
                mc.placardhitmc.regX = 80;
                mc.placardhitmc.regY = 300;
                mc.placardhitmc.x = 117;
                mc.placardhitmc.y = 200;
                mc.placardhitmc.visible = false;
                mc.addChild(mc.placardhitmc);
            }
            
            
            if (!params.menu && !params.placard){
                var containerB = new createjs.Container();
                mc.addChild(containerB);
                this.powerbar = new BD.Powerbar({dest:containerB, x:20, y:-40, scale:0.8});
            }
            
            if (!params.clarkson){
                setTimeout(makedecision, decision_interval);
            } else {
                mc.defaulty = 50;
                tweening = createjs.Tween.get(mc, {override:true}).to({y:mc.defaulty}, 250).call(function(){tweening = false});
				shooting = true;
                doShootAtPlayer();
            }
            
            posy = mc.defaulty; 
            
            //new BD.Powerbar({dest:mc});
            /*
            posy = -10;
            mc.y = posy;
            mc.x = 300;
            */
        }
		
        this.setValue = function(val){
            powerbar.setValue(val)
        }
        
		function makedecision(){				
            if (gameActive){
                speed_inc = 1+Math.random()
                direction = Math.floor(Math.random()*3);

                posy = Math.random()<0.4 ? mc.defaulty+120 : mc.defaulty;

                if (!params.placard){
                    if (Math.random()<0.5 && posy == mc.defaulty) {
                        shooting = true;
                        doShootAtPlayer();
                    } else {
                        shooting = false;
                    }
                }

                tweening = createjs.Tween.get(mc, {override:true}).to({y:posy}, 250).call(function(){tweening = false});
                createjs.Tween.get(mc.mchead, {override:true}).to({rotation:-10+Math.random()*30}, 500).call(function(){});
                if (mc.placardmc){
                    createjs.Tween.get(mc.placardmc, {override:true}).to({rotation:-10+Math.random()*30}, 500).call(function(){});
                }    
            }
            if (active){
                setTimeout(makedecision, decision_interval);
            }
        }
        
        function doShootAtPlayer(){ 
            var enemy = enemymanager.getRandomEnemy();
            if (enemy){
                var p1 = {x:enemy.getPos().x, y:enemy.getPos().y+70};
                var p2;
				if (params.clarkson){
					p2 = {x:enemy.getPos().x-150+Math.random()*250, y:enemy.getPos().y-150+Math.random()*250};
				} else {
					p2 = {x:player.getPos().x, y:player.getPos().y+70};
				}
                balls.shoot(p1, p2);
                
                mc.gunfiremc.visible = true;
                mc.gunfiremc.scaleX = 0
                mc.gunfiremc.scaleY = 0
                createjs.Tween.get(mc.gunfiremc, {override:true}).to({scaleX:1.5, scaleY:1.5}, 200).call(function(){
                    createjs.Tween.get(mc.gunfiremc, {override:true}).to({scaleX:0, scaleY:0}, 200).call(function(){
                        mc.gunfiremc.visible = false;
                    });
                });
                
            } else {
                console.log("NO ENEMY EXISTS")
            }

            if (shooting && gameActive){
                setTimeout(doShootAtPlayer, 200);
            }
        }

		this.setPos = function(vect){
			if (vect.x){
				mc.x = vect.x;
                if (vect.default){
                    mc.defaultx = vect.x; 
                }
			}
			if (vect.y){
				mc.y = vect.y;
                if (vect.default){
                    mc.defaulty = vect.y; 
                }
			}
            if (!posy){
                posy = mc.defaulty+400;
            }
		}
        
        this.getMc = function(){
			return mc;
        }
        
		this.getPos = function(){
			return {x:mc.x, y:mc.y};
		}
		
        this.isPlacard = function(){
			return params.placard;
        }
        
        this.isShooting = function(){
            return shooting;
        }
        
		this.incPos = function(vect){
			if (vect.x){
				mc.x += vect.x;
			}
			if (vect.y){
				mc.y += vect.y;
			}
        }
        
        this.update = function(){
            
            if (params.clarkson){
                mc.arm.rotation -= 25;
                
            } else {
                if (shooting){
                    var p1 = player.getPos(); //crosshair.getPos();
                    var p2 = mc.localToGlobal(mc.arm.x, mc.arm.y);
                    var degrees = Math.atan((p1.x-p2.x)/(p1.y-p2.y))/(Math.PI/180)
                    if  (p1.y < p2.y) degrees += 180;
                    mc.arm.rotation = -Math.floor(degrees/10)*10;
                } else {
                    createjs.Tween.get(mc.arm, {override:true}).to({rotation:0}, 250);
                }
            }
            
            //mc.armhit.rotation = mc.arm.rotation
            mc.mchithead.rotation = mc.mchead.rotation
            
            if (mc.placardmc && mc.placardhitmc){
                mc.placardhitmc.rotation = mc.placardmc.rotation
            }
            
            /*
            var x = mc.x;
            if ( x > (stage.canvas.width/2) ){
                mc.scaleX = mc.defaultScaleX; 
            } else {
                mc.scaleX = -mc.defaultScaleX;
            }
            */
            
            var x = mc.x;
            if ( x > (stage.canvas.width/2) ){
                mc.arm.scaleX = 1; 
                
            } else {
                mc.arm.scaleX = -1;

            }
            
            if (!run_for_cover){
                
                 switch (direction){
                    case MOVE_LEFT : 
                        mc.x -= SPEED*speed_inc; break;
                    case MOVE_RIGHT : 
                        mc.x += SPEED*speed_inc; break;
                    default : 
                        break;
                }

                if (mc.x < 0){
                    mc.x = 0;
                    if (params.clarkson){
                        this.destroy();
                    }
                    //makedecision();
                }
                if (mc.x > stage.canvas.width){
                    mc.x = stage.canvas.width;
                    //makedecision();
                }
                
                if (!tweening && !params.clarkson){
                    mc.y = posy + Math.cos(mc.x/8)*3;
                }
                /**/
                
            } else {
                //yes... run for cover
                mc.x -= SPEED*3;
                //mc.scaleX = 0.5;
                
                if (mc.x < 0){
                    mc.x = 0;
                    //makedecision();
                    run_for_cover = false;
                    //mc.scaleX = 1.3;
                }
            }
        }
        
        this.destroy = function(){
            shooting = false;
            tweening = createjs.Tween.get(mc).to({y:mc.defaulty+300}, 250).call(function(){
                tweening = false
                stage.removeChild(mc);
            });
            active = false;
        }
        
    }
    
    BD.Enemy = Enemy;
    
}())