this.BD = this.BD || {};

(function(){

    function EnemyManager(){
        
        var _this = this;
		var enemies = [];
		
        var spawn_interval = 500;
        var max_enemies = 1;
        

        this.init = function(){
            this.initcreate();
        }
        
        
        this.initcreate = function(){
            if (enemies.length<max_enemies){
                _this.create();
            }
        }
        
        this.create = function(p){
            var params = p || {};
            var enemy = new BD.Enemy(params);
			var x = params.clarkson ? 800 : 150+Math.random()*500;  // / ratiow;
			var y =  stage.canvas.height - 340;//150-120 // / ratioh; 
			enemy.setPos({x:x, y:y, default:true});
			enemies.push({inst:enemy, mc:enemy.getMc()});
            enemy.setPos({y:y+500});
            return enemy;
        }
		
        this.getRandomEnemy = function(){
            return enemies[0].inst;
        }
        
        this.remove = function(en){
            /*
            stage.removeChild(en.mc);
            en.inst = null;
            en = null;
            */
            //enemies.push({inst:enemy, mc:enemy.getMc()});
        }
        
        this.setPowebarValue = function(val){
            for (var i=0; i<enemies.length; i++){
                if (enemies[i]){
                    enemies[i].inst.setValue(val);
                }
            }
        }
        
        this.update = function(){
            //check if enemy hit
            BD.behindBarrier = false;
            
            if (player.getMc().x>300 && player.getMc().x<stage.canvas.width-100){    
                BD.behindBarrier = true;
            }

            //HIT TESTING
            
            //check if enemy hit
            BD.enemyShooting = false;
            
            for (var i=0; i<enemies.length; i++){
                if (enemies[i]){
                    enemies[i].inst.update();
                    
                    //for checking if player is hit
                    if (enemies[i].inst.isShooting()){
                        BD.enemyShooting = true;
                    }
                    
                    if (!barriers.hitBarrier()){
                        if (game.playerIsShooting()){
                            var cr = crosshair.getPos();
                            var body = enemies[i].mc.mc1.globalToLocal(cr.x, cr.y) 
                            var head = enemies[i].mc.mchead.globalToLocal(cr.x, cr.y) 
                            if (enemies[i].mc.mc1.hitTest(body.x, body.y) || enemies[i].mc.mchead.hitTest(head.x, head.y)){
                                
                                if (!enemies[i].mc.hitmc.visible){
                                    enemies[i].mc.hitmc.visible = true;
                                    enemies[i].mc.mchithead.visible = true;
                                    enemies[i].mc.armhit.visible = true;
                                    
                                    var mc = enemies[i].mc;
                                    createjs.Tween.get(mc).to({scaleX:mc.defaultScaleX-0.05, scaleY:mc.defaultScaleX-0.05, rotation:mc.rotation-2+Math.random()*4}, 100).wait(1).to({scaleX:mc.defaultScaleX, scaleY:mc.defaultScaleX, rotation:0}, 100);
            
                                    setTimeout(function(enemy){
                                        if (enemy.inst){
                                           var mc = enemy.mc;
                                            mc.hitmc.visible = false;
                                            mc.mchithead.visible = false;
                                            mc.armhit.visible = false;

                                            if (enemy.inst.isPlacard()){
                                                placardplayer = false;
                                                enemy.inst.destroy();
                                           } else {
                                                player2score -= 1;
                                                score += 1;
                                           }
                                        }
                                        
                                    }, 50, enemies[i]);
                                }
                            }
                            
                            
                            // hit placard
                            if (enemies[i].mc.placardmc){
                                var placard = enemies[i].mc.placardmc.globalToLocal(cr.x, cr.y) 
                                if (enemies[i].mc.placardmc.hitTest(placard.x, placard.y)){

                                    if (!enemies[i].mc.placardhitmc.visible){
                                        enemies[i].mc.placardhitmc.visible = true;

                                        setTimeout(function(mc){
                                            mc.placardhitmc.visible = false;
                                            score += 5;
                                        }, 50, enemies[i].mc);
                                    }
                                }
                            }

                        }
                    }
                }
            }
            
            //check if player hit
            // - if not behind barrier
            // - if head up
            if (BD.enemyShooting){
                if (BD.behindBarrier && !player.getMc().exposed){
                    // cant be shot
                } else {
                    //clearTimeout(_this.TO2);
                    if (!player.getMc().hitmc.visible){
                        player.getMc().hitmc.visible = true;
                        player.getMc().armhit.visible = true;
                        player.getMc().backhead.visible = false;
                        
                        var mc = player.getMc();    
                        createjs.Tween.get(mc).to({scaleX:mc.defaultScaleX-0.1, scaleY:mc.defaultScaleX-0.1, rotation:mc.rotation-0+Math.random()*0}, 100).wait(1).to({scaleX:mc.defaultScaleX, scaleY:mc.defaultScaleX, rotation:0}, 150);

						var dur;
						if (skill<3){
							dur = 150-((skill)*50) ; // 150, 100, 50
						} else {
							dur = 40-((skill)*10) ; // 40, 30, 20
						}
						
                        setTimeout(function(mc){
                            mc.hitmc.visible = false;
                            mc.armhit.visible = false;
                            player1score -= 1;
                        }, dur, player.getMc());
                    }
                }
            }
        }
        
        this.destroy = function(){
            for (var i=0; i<enemies.length; i++){
                if (enemies[i]){
                    enemies[i].inst.destroy();
                }
            }
        }
    }
    
    BD.EnemyManager = EnemyManager;
    
}())