this.BD = this.BD || {};

var canvas,
	queue,
	stage;

var loadingtext;

var score = 0;
var level = 1;
var skill = 0;
var playerid;

var game;
var menu, menuvote;

var TESTING = 0;


(function(){

    function Main(){
		
		var _this = this;
        
        canvas = document.getElementById("testCanvas");
        stage = new createjs.Stage(canvas);

        loadingtext = new createjs.Text("Loading...", "28px chunkfive", "#fff");
        loadingtext.width = 305;
        loadingtext.x = 330
        loadingtext.y = 190
        stage.addChild(loadingtext);
		
        stage.update();
        
		//-- music
		//BD.sound_music = "audio/music.mp3"
		//BD.sound_splat = "audio/Splat-SoundBible.com-1826190667.mp3"
		//BD.sound_pop = "audio/Blop-Mark_DiAngelo-79054334.mp3";
		
		
		createjs.Sound.registerSound("audio/snd_carto33_free-loops.com.mp3", "button");
		createjs.Sound.registerSound("audio/snd_camel39_free-loops.com.mp3", "clarkson");
		createjs.Sound.registerSound("audio/music_reduced.mp3", "music");
		createjs.Sound.registerSound("audio/Splat-SoundBible.com-1826190667.mp3", "splat");
		createjs.Sound.registerSound("audio/Blop-Mark_DiAngelo-79054334.mp3", "pop1");
		createjs.Sound.registerSound("audio/snd_cork66_free-loops.com.mp3", "pop2");
		
		createjs.Sound.registerSound("audio/snd_bulle0_free-loops.com.mp3", "hit1");
		createjs.Sound.registerSound("audio/snd_bulle22_free-loops.com.mp3", "hit2");
		createjs.Sound.registerSound("audio/snd_bulle31_free-loops.com.mp3", "hit3");
		
		
        // PRELOADING ------------
        queue = new createjs.LoadQueue();
        queue.installPlugin(createjs.Sound);
        queue.on("complete", handleComplete, this);
        queue.on("fileprogress", handleProgress, this);
        var filestoload = [
            //splash
            {id: "home_bg", src:"img/splash/home_bg.jpg"},
            {id: "home_logo", src:"img/splash_title2.png"},
            
            {id: "crosshair", src:"img/crosshair.png"},
            {id: "conker1", src:"img/conker1.png"},
            {id: "controls_btn_left", src:"img/controls_btn_left.png"},
            {id: "controls_btn_right", src:"img/controls_btn_right.png"},
            {id: "controls_btn_shoot", src:"img/controls_btn_shoot.png"},
            {id: "person", src:"img/person.png"},
            {id: "person_head_up", src:"img/person_head_up.png"},
            {id: "person_2", src:"img/person_2.png"},
            {id: "person_2_hit", src:"img/person_2_hit.png"},
            {id: "powerbar_empty", src:"img/powerbar_full.png"},
            {id: "powerbar_bit", src:"img/powerbar_bit.png"},
            {id: "ball", src:"img/ball.png"},
            {id: "box", src:"img/box.png"},
            {id: "boxv", src:"img/boxv.png"},
            {id: "box_hit", src:"img/box_hit.png"},
            {id: "boxv_hit", src:"img/boxv_hit.png"},
            {id: "splat", src:"img/splat_orange.png"},
            {id: "youwin", src:"img/youwin.png"},
            {id: "youlose", src:"img/youlose.png"},
            {id: "getready", src:"img/getready.png"},
            {id: "gametitle", src:"img/gametitle.png"},
            {id: "homescreenbutton", src:"img/homescreenbutton.png"},
            //{id: "splat", src:"img/splatss2.png"},
            
            {id: "house_of_parl_bg", src:"img/house_of_parl_bg.png"},
            //{id: "house_of_parl_fg", src:"img/house_of_parl_fg.png"},
            {id: "house_of_parl_fg_all", src:"img/house_of_parl_fg_all.png"},
            //{id: "house_of_parl_fg_HIT", src:"img/house_of_parl_fg_HIT.png"},
            //{id: "house_of_parl_fg_HIT_light", src:"img/house_of_parl_fg_HIT_light.png"},
            
            {id: "london_eye_bg", src:"img/london_eye_bg.jpg"},
            {id: "london_eye_fg", src:"img/london_eye_fg.png"},
            {id: "london_eye_sky_hit", src:"img/london_eye_sky_hit.png"},
            
            {id: "tower_bridge", src:"img/tower_bridge.jpg"},
            {id: "tower_bridge_fg", src:"img/tower_bridge_fg.png"},
            {id: "tower_bridge_sky_hit", src:"img/tower_bridge_sky_hit.png"},
            
            //{id: "ammo", src:"img/ammo.png"},
            
            
            {id: "UKPaintball_logo_300", src:"img/UKPaintball_logo_300.jpg"},
            
            
            {id: "char_cameron_back", src:"img/char_cameron_back_noarm_orhead.png"},
            {id: "char_cameron_back_arm", src:"img/char_cameron_back_arm.png"},
            {id: "char_cameron_back_arm_hit", src:"img/char_cameron_back_arm_hit.png"},
            {id: "char_cameron_back_hit", src:"img/char_cameron_back_hit.png"},
            {id: "char_cameron_front", src:"img/char_cameron_front_noarm_or_head.png"},
            {id: "char_cameron_front_hit", src:"img/char_cameron_front_noarm_or_head_hit.png"},
            {id: "char_cameron_head_hit", src:"img/char_cameron_head_hit.png"},
            {id: "char_cameron_front_arm", src:"img/char_cameron_front_arm.png"},
            
            {id: "char_milliband_head", src:"img/char_milliband_head.png"},
            {id: "char_cameron_head", src:"img/char_cameron_head.png"},
            {id: "char_farage_head", src:"img/char_farage_head.png"},
            {id: "char_donkey_head", src:"img/char_donkey_head.png"},
            {id: "char_clarkson_head", src:"img/char_clarkson_head.png"},
            {id: "char_clarkson_head_hit", src:"img/char_clarkson_head_hit.png"},
            //{id: "char_donkey_head", src:"img/char_jabba_head.png"},
            //{id: "char_donkey_head", src:"img/funny-caricature-9.png"},
            {id: "char_clegg_head", src:"img/char_clegg_head.png"},
            {id: "char_farage_head_back", src:"img/char_farage_head_back.png"},
            {id: "char_cameron_head_back", src:"img/char_cameron_head_back.png"},
            {id: "char_milliband_head_back", src:"img/char_milliband_head_back.png"},
            {id: "char_clegg_head_back", src:"img/char_cameron_head_back.png"},
            
            
            {id: "gunfire", src:"img/gunfire.png"},
            
            {id: "placard", src:"img/placard.png"},
            {id: "placardhit", src:"img/placardhit.png"},
            
            {id: "home_loz", src:"img/home_loz.png"},
            {id: "btn_play", src:"img/btn_play.png"},
            {id: "btn_back", src:"img/btn_back.png"},
            {id: "btn_howtoplay", src:"img/btn_howtoplay.png"},
            
            {id: "vote_loz", src:"img/vote_loz.png"},
            {id: "vote_bar_red", src:"img/vote_bar_red.png"},
            {id: "vote_bar_blue", src:"img/vote_bar_blue.png"},
            {id: "vote_bar_yellow", src:"img/vote_bar_yellow.png"},
            {id: "vote_bar_purple", src:"img/vote_bar_purple.png"},
            {id: "votetick", src:"img/votetick.png"},
            {id: "lensflare", src:"img/lensflare2.png"},
        ]
        queue.loadManifest(filestoload);

            
        function handleComplete() {
            stage.removeChild(loadingtext);
            init();
        }

        var loadcount = 0; 
        function handleProgress(evt) {
            if (evt.progress==1){
                //console.log("handleProgress "+evt.progress)
                loadcount++;
                var txt = "Loading... "+Math.floor((loadcount/filestoload.length)*100)+"%";
				loadingtext.text = txt;
                //console.log("handleProgress "+txt)
                var mcbmp = queue.getResult("home_bg")
                if (mcbmp){
                    mc = new createjs.Bitmap(mcbmp);
                    stage.addChild(mc);
                    stage.addChild(loadingtext);
					
                    //mc.scaleX=BD.screenWidth/mcbmp.width*0.834;
					//mc.scaleY=BD.screenHeight/mcbmp.height*0.834;
					mc.scaleX=1050/mcbmp.width*0.834;
                    mc.scaleY=480/mcbmp.height*0.834;
                }
            }
            this.onResize();
            stage.update();
        }
            
        function init(){	
            createjs.Ticker.addEventListener("tick", tick);
            createjs.Ticker.setFPS(30);
            for (var c=0;c<10;c++){
                var p = new createjs.Container();
                stage.addChildAt(p, c);
            }
            
            if (TESTING){
                level = 1;
                playerid = 2;
                startGame();
                //menu = new BD.Menu({callback:startGameClicked});
                //menu = new BD.MenuVote({callback:startGameClicked});
            } else {
                showSplash();
            }
            
        }
            
        function showSplash(){
            score = 0;
            level = 1;
            skill = 0;
            stage.removeAllChildren(); 
            menu = new BD.Menu({callback:startGameClicked, callback2:howtoClicked});
        }   
            
        function startGameClicked(){
            if (!menuvote){
                stage.removeAllChildren(); 
                menuvote = new BD.MenuVote({callback:voteClicked});
            }
        }
            
        function howtoClicked(){
            stage.removeAllChildren(); 
            new BD.HowToPlay({callback:showSplash});
        }
            
            
        function voteClicked(lvl){
            menuvote = null;
            playerid = lvl;
            startGame();
        }
        
        function startGame(){
            stage.clear();
            stage.removeAllChildren();    
            if (!game){
                game = new BD.Game({gamedonecallback:gamedone});
            }
        }
            
        function gamedone(result){
            game = null;
            stage.clear();
            stage.removeAllChildren();
            if (result == "win"){
                skill++;
                level++;
                if (level>3){
                    level = 1;
                }
                startGame();
            } else {
                showSplash();
            }
        }
            
        function tick(evt){
            if (game){
                game.tick(evt);
            }
            stage.update();
        }
            
        this.onResize = function(){            
            var w = 850*(window.innerHeight/400)
            var h = window.innerHeight;
            var MAX = 1.2;
            if (w>850*MAX){
                w = 850*MAX
            }
            if (h>400*MAX){
                h = 400*MAX
            }
			BD.screenWidth = w;
			BD.screenHeight = h;
            ratiow = w/850; // w/720;
			ratioh = h/400; //h/400;
            var el = document.getElementById("testCanvas");
            xoff = ((window.innerWidth-w)/2);
            el.style.left = xoff+"px";
            el.style.width = w+"px";
            el.style.height = h+"px";
            //reposition();
        }   
        
    }
    
    BD.Main = Main;
    
}())

function is_touch_device() {  
  try {  
    document.createEvent("TouchEvent");  
    return true;  
  } catch (e) {  
    return false;  
  }  
}
