this.BD = this.BD || {};

// http://berthasworkers.com/dev/paintball/php/functions.php?mode=create
// http://berthasworkers.com/dev/paintball/php/functions.php?mode=addVote&id=1
// http://berthasworkers.com/dev/paintball/php/functions.php?mode=get
// http://berthasworkers.com/dev/paintball/php/functions.php?mode=increaseVote&id=1
// http://berthasworkers.com/dev/paintball/php/functions.php?mode=setVote&id=1
// http://berthasworkers.com/dev/paintball/php/functions.php?mode=addVote&id=3&value=100


(function(){

    function MenuVote(o){
        
		var params = o;
        
        
        
        var arr = [
            {name:"David Cameron", asset:"char_cameron_head", barasset:"vote_bar_blue"},
            {name:"Ed Miliband", asset:"char_milliband_head", barasset:"vote_bar_red"},
            {name:"Nigel Farrage", asset:"char_farage_head", barasset:"vote_bar_purple"},
            {name:"Nick Clegg", asset:"char_clegg_head", barasset:"vote_bar_yellow"}
        ]
        
        var xpos = 200;
        var ypos = 40;
        
		init();

        function init(){				
            
            var mcbmp = queue.getResult("home_bg")
            var mc = new createjs.Bitmap(mcbmp);
            mc.x = 0; 
            mc.y = 0;
            stage.addChild(mc);
            
			//mc.scaleX=BD.screenWidth/mcbmp.width*0.834;
			//mc.scaleY=BD.screenHeight/mcbmp.height*0.834;
			mc.scaleX=1050/mcbmp.width*0.834;
			mc.scaleY=480/mcbmp.height*0.834;
			
            //mc.scaleX=1;
            //mc.scaleY=0.5;
            
			var mcbmp = queue.getResult("home_logo")
            mc = new createjs.Bitmap(mcbmp);
            mc.x = stage.canvas.width/2;
            mc.y = 90;
            mc.regX = mcbmp.width/2;
            mc.regY = mcbmp.height/2;
            mc.scaleX = 0.5;
            mc.scaleY = mc.scaleX;
            stage.addChild(mc);
            
            //createjs.Tween.get(mc).to({x:xpos-100, y:40, scaleX:0.2, scaleY:0.2}, 400, createjs.Ease.quadOut);
            createjs.Tween.get(mc).to({x:xpos-85, y:30, scaleX:0.15, scaleY:0.15}, 400, createjs.Ease.quadOut);
            
            getServerData();
            
            //createEntry(10);
            //createEntry(20);
        }
        
        function getServerData(){
            var url = "http://berthasworkers.com/dev/paintball/php/functions.php?mode=get";
            console.log("url "+url)
            $.ajax({
                url: url
            }).done(function(evt) {
                console.log(evt)
                var spl = evt.split(",");
               
                //calc %
                var totalvotes = 0;
                for (var i=0; i<spl.length; i++){
                    if (spl[i]){
                        arr[i].votes = Math.floor(spl[i]);
                        totalvotes += arr[i].votes;
                    }
                }
                
                for (var i=0; i<spl.length; i++){
                    if (spl[i] && arr[i].name){
                        var perc = Math.round((arr[i].votes/totalvotes)*100);
                        createEntry((i+1), arr[i].name, arr[i].asset, arr[i].barasset, arr[i].votes, perc);
                    }
                }
            });
        }
        
        
        function setVote(id){
            var url = "http://berthasworkers.com/dev/paintball/php/functions.php?mode=increaseVote&id="+id;
            $.ajax({
                url: url
            }).done(function(evt) {
                console.log(evt)
            });
        }
        
        function createEntry(i, name, asset, barasset, votes, perc){   
            
            var holder = new createjs.Container();
            stage.addChild(holder);
            
            var mcbmp = queue.getResult(barasset)
            var mc1 = new createjs.Bitmap(mcbmp);
            mc1.x = xpos+305
            mc1.y = ypos+20
            holder.addChild(mc1);
            
            mc1.scaleX=6*perc/100;
            mc1.scaleY=1;
            
            //createjs.Tween.get(holder).to({x:0}, 200);
            
            //----------
            var mcbmp = queue.getResult("vote_loz")
            var mc2 = new createjs.Bitmap(mcbmp);
            mc2.x = xpos
            mc2.y = ypos
            holder.addChild(mc2);
            
            mc2.scaleX=0.6;
            mc2.scaleY=mc2.scaleX;
        
            
            //-----
            var mcbmp = queue.getResult("votetick")
            var mc3 = new createjs.Bitmap(mcbmp);
            mc3.x = xpos + 450
            mc3.y = ypos + 10
            holder.addChild(mc3);
            
            mc3.scaleX=0.6;
            mc3.scaleY=mc3.scaleX;
        
            mc2.charid = i;
            mc3.charid = i;
            holder.charid = i;
            
            mc2.addEventListener("click", function(event) {
                console.log(event.target.charid)
				createjs.Sound.play("button");
                setVote(event.target.charid)
                params.callback(event.target.charid);
            })
			mc3.addEventListener("click", function(event) {
                console.log(event.target.charid)
				createjs.Sound.play("button");
                setVote(event.target.charid)
                params.callback(event.target.charid);
            })
            
            
            //--------
            var mcbmp = queue.getResult(asset)
            var mc = new createjs.Bitmap(mcbmp);
            mc.x = xpos-0
            mc.y = ypos-20
            holder.addChild(mc);
            
            mc.scaleX=0.50;
            mc.scaleY=mc.scaleX;
            
            //----------
            //text vote
            var txt = new createjs.Text(name, "18px chunkfive", "#000");
            //txt.shadow = new createjs.Shadow("#000000", 1, 1, 1);
            txt.x = xpos+70
            txt.y = ypos+19
            holder.addChild(txt);
            
            //text vote
            var txt = new createjs.Text(votes+" votes", "18px chunkfive", "#ffff00");
            txt.shadow = new createjs.Shadow("#000000", 1, 1, 1);
            txt.x = xpos+70
            txt.y = ypos+48
            holder.addChild(txt);
            
            
            //text vote
            var txt = new createjs.Text(perc+"%", "18px chunkfive", "#000");
            txt.x = xpos+190
            txt.y = ypos+48
            holder.addChild(txt);
            
            holder.x = -500;
            createjs.Tween.get(holder).to({x:0}, 200);
            
            
            ypos += 90;
        }
        
    }
    
    BD.MenuVote = MenuVote;
    
}())