this.BD = this.BD || {};

(function(){

    function Player(){
        
		var player;
		var powerbar;
        
        init();

        function init(){		
            player = new createjs.Container();
            stage.addChildAt(player, 10);
            player.scaleX = 0.65;
			player.scaleY = player.scaleX;
            player.defaultScaleX = player.scaleX;
            
            //player.shadow = new createjs.Shadow("#000000", 5, 5, 1);
            
			var playerbmp = queue.getResult("char_cameron_back")
			player.mc1 = new createjs.Bitmap(playerbmp);
			player.mc1.regX = 43;
			
            //
            
            
            /*
            var armbmp = queue.getResult("char_cameron_back_arm")
			player.arm = new createjs.Bitmap(armbmp);
			player.arm.x = 67;
			player.arm.y = 200;
            player.arm.regX = 150;
            player.arm.regY = 150;
			player.addChild(player.arm);
            
            var armbmp = queue.getResult("char_cameron_back_arm_hit")
            player.armhit = new createjs.Bitmap(armbmp);
			player.armhit.x = 67;
			player.armhit.y = 200;
            player.armhit.regX = 150;
            player.armhit.regY = 150;
			player.armhit.visible = false;
			//player.addChild(player.armhit);
            */
            
            player.arm = new createjs.Container();
            player.addChild(player.arm);
            player.arm.x = 67;
			player.arm.y = 200;
            
            var armbmp = queue.getResult("char_cameron_back_arm")
			player.armmc = new createjs.Bitmap(armbmp);
			//mc.armmc.x = 67;
			//mc.armmc.y = 200;
            player.armmc.regX = 150;
            player.armmc.regY = 150;
			player.arm.addChild(player.armmc);
            
            var armbmp = queue.getResult("char_cameron_back_arm_hit")
			player.armhit = new createjs.Bitmap(armbmp);
			//mc.armhit.x = 67;
			//mc.armhit.y = 200;
            player.armhit.regX = 150;
            player.armhit.regY = 150;
            player.armhit.visible = false;
			player.arm.addChild(player.armhit);
            
            var armbmp = queue.getResult("gunfire")
			player.gunfiremc = new createjs.Bitmap(armbmp);
			player.gunfiremc.x = 60;
			player.gunfiremc.y = 150;
            player.gunfiremc.regX = 75;
            player.gunfiremc.visible = false;
            //mc.gunfiremc.regY = 150;
			player.arm.addChild(player.gunfiremc);
            
            
            
            player.addChild(player.mc1);
            
            var asset;
            if (playerid == 1){
                asset = "char_cameron_head"
            } else if (playerid == 2){
                asset = "char_milliband_head"
            } else if (playerid == 3){
                asset = "char_farage_head"
            }  else {
                asset = "char_clegg_head"
            }
            var armbmp = queue.getResult(asset);
            player.backhead = new createjs.Bitmap(armbmp);
			//player.backhead.x = 67;
			//player.backhead.y = 200;
            player.backhead.regX = 30;
            player.backhead.regY = -5;
            player.backhead.visible = false;
			player.addChild(player.backhead);
            setInterval(makedecision, 4000);
            
            /*
            var playerbmp = queue.getResult("char_cameron_back")
			player.mc2 = new createjs.Bitmap(playerbmp);
			player.mc2.regX = 43;
			player.mc2.regY = 100;
			player.addChild(player.mc2);
            player.mc2.visible = false;
            */
            
            
            // --- head ----
            var asset;
            if (playerid == 1){
                asset = "char_cameron_head_back"
            } else if (playerid == 2){
                asset = "char_milliband_head_back"
            } else if (playerid == 3){
                asset = "char_farage_head_back"
            }  else {
                asset = "char_clegg_head_back"
            }
            
            var bmp = queue.getResult(asset);
            var mchead = new createjs.Bitmap(bmp);
			player.mchead = mchead 
            player.mchead.regX = 37;
            player.mchead.regY = 205;
            player.mcheadx = 90;
            player.mchead.y = 210;
			player.addChild(player.mchead);
            var containerB = new createjs.Container();
            player.addChild(containerB);
            powerbar = new BD.Powerbar({dest:containerB, x:-60, y:-40, scale:0.8});
            
            
            
            var bmp = queue.getResult("char_cameron_back_hit")
			player.hitmc = new createjs.Bitmap(bmp);
			player.hitmc.regX = 43;
			player.hitmc.visible = false;
			player.addChild(player.hitmc);
            
			player.on("mousedown", function(evt) { dragging=true; });
			player.on("pressup", function(evt) { dragging=false; });
			
        }
		
        function makedecision(){
            if (Math.random()<0.5){
                player.mchead.visible = false;
                player.backhead.visible = true;
                setTimeout(function(){
                    player.mchead.visible = true;
                    player.backhead.visible = false;
                }, 2000);
            }
        }
        
        this.shoot = function(){
            player.mchead.visible = true;
            player.backhead.visible = false;
            player.gunfiremc.visible = true;
            player.gunfiremc.scaleX = 0
            player.gunfiremc.scaleY = 0
            createjs.Tween.get(player.gunfiremc, {override:true}).to({scaleX:1.5, scaleY:1.5}, 200).call(function(){
                createjs.Tween.get(player.gunfiremc, {override:true}).to({scaleX:0, scaleY:0}, 200).call(function(){
                    player.gunfiremc.visible = false;
                });
            });
        }
        
        
        this.setPowebarValue = function(val){
            powerbar.setValue(val)
        }
        
		this.setPos = function(vect){
			if (vect.x){
				player.x = vect.x;
			}
			if (vect.y){
				player.y = vect.y;
                if (vect.default){
                    player.defaulty = vect.y; 
                }
			}
		}
        
		this.getPos = function(){
			return {x:player.x, y:player.y};
		}
		
        this.getExposed = function(){
			return player.exposed;
		}
        
		this.incPos = function(vect){
			if (vect.x){
				player.x += vect.x;
			}
			if (vect.y){
				player.y += vect.y;
			}
		}
        
        this.getMc = function(){
			return player;
        }
        
        this.update = function(){
            ///ratioh
            /*
            if ( (crosshair.getPos().y) < (player.y-30) ){
                player.exposed = true;
                player.mc1.visible = false;    
                player.mc2.visible = true;    
            } else {
                player.exposed = false;
                player.mc1.visible = true;    
                player.mc2.visible = false;
            }
            */
            
            //var degrees = Math.atan((crosshair.getPos().x-player.arm.x)/(crosshair.getPos().y-player.arm.y))/(Math.PI/180)
            var p2 = player.localToGlobal(player.arm.x, player.arm.y);
           
            //var pt = this.localToGlobal(x, y);
            //pt = target.globalToLocal(pt.x, pt.y);
            
            var degrees = Math.atan((crosshair.getPos().x-p2.x)/(crosshair.getPos().y-p2.y))/(Math.PI/180)
            if  (crosshair.getPos().y < p2.y) degrees += 180;
            player.arm.rotation = -10-Math.floor(degrees/10)*10
            
            //player.armhit.rotation = player.arm.rotation
            //mc.mchithead.rotation = mc.mchead.rotation
            
            
            
            if (player.defaulty){
                if ( (crosshair.getPos().y) < (player.defaulty) ){
                    if (!player.exposed){
                        player.exposed = true;
                        createjs.Tween.get(player, {override:true}).to({y:player.defaulty-50}, 50);
                    }
                } else {
                    if (player.exposed){
                        player.exposed = false;
                        createjs.Tween.get(player, {override:true}).to({y:player.defaulty}, 50);
                    }
                }
            }
            
            if (!player.exposed){
                player.y = player.defaulty + Math.cos(player.x/10)*5;
            }
            
            var x = crosshair.getPos().x;
            if ( x > (player.x-0) ){
                player.arm.scaleX = 1; 
                
            } else {
                player.arm.scaleX = -1;

            }
            
            /*
            if ( x > (player.x-0) ){
                player.scaleX = player.defaultScaleX; 
                
            } else {
                player.scaleX = -player.defaultScaleX;

            }
            */
            player.x += ((x-player.x)/20);
                
        }
		
    }
    
    BD.Player = Player;
    
}())