this.BD = this.BD || {};

(function(){

    function Powerbar(o){
        
        var params = o;
        
        var powerbits = [];
        var power = 0;
        var powerdir = 1;
        
        init();

        function init(){
        
            var container = new createjs.Container();
            params.dest.addChild(container);
            container.x = params.x || 280;
            container.y = params.y || 10;
            container.scaleX = params.scale || 1;
            container.scaleY = container.scaleX;
                
            if (params.bottom){
                container.y = 360;
            }
            
            var powerbarbmp = queue.getResult("powerbar_empty")
            var powerbar = new createjs.Bitmap(powerbarbmp);
            powerbar.alpha = 0.6;
            container.addChild(powerbar);

            
            for (var i=0;i<20;i++){
                var powerbarbitbmp = queue.getResult("powerbar_bit")
                var powerbarbit = new createjs.Bitmap(powerbarbitbmp);
                powerbarbit.x = powerbar.x+4+(i*10);
                powerbarbit.y = powerbar.y+4;
                container.addChild(powerbarbit);
                powerbits.push(powerbarbit);
            }

            /*
            var powerInt = setInterval(function(){
                power += powerdir;
                if (power == 21){
                    powerdir = -1;
                } else if (power == 0){
                    powerdir = 1;
                }
                for (var i=0;i<20;i++){
                    powerbits[i].visible = power>i ? true : false;
                }
            }, 1005);
            */
        }
        
        this.setValue = function(val){
            for (var i=0;i<20;i++){
                powerbits[i].visible = (val/(100/20))>i ? true : false;
            }
        }
        
    }
    
    BD.Powerbar = Powerbar;
    
}())